import { JSONSerializer } from './ser'
import { deserialize, Deserialize } from 'serde/de'
import { JSONDeserializer } from './de'
import { serialize } from 'serde/ser'

export function toString(value: any): string {
  const serializer = new JSONSerializer()
  serialize(serializer, value)
  return serializer.output
}

export function fromString<T, D extends Deserialize<T>>(value: string, into: D): T {
  const deserializer = JSONDeserializer.fromString(value)
  return deserialize(deserializer, into)
}

